proc MainDlgProc,hdlg,uMsg,wparam,lparam
	stack hPriEdit_ex,4
	pusha
	mov eax, dword [@uMsg]
	if eax,e,WM_DESTROY
		call PostQuitMessage, 0	
		xor eax,eax
		jmp near returntrue
	endif
	if eax,e,WM_INITDIALOG
		call SetWindowTextA,[@hdlg],Windowname
		
		call SetDlgItemTextA,[@hdlg],IDD_STATUS,NotConnected
		call SendDlgItemMessageA,[@hdlg],IDD_YOU,EM_LIMITTEXT,8192,0
		
		call SetDlgItemTextA,[@hdlg],IDD_STATUS,NotConnected
		call UpdateWindow,[@hdlg]
		
		mov eax,[@hdlg]
		mov dword[mainwinhandle],eax      ;; store the main dialog handle useful for private mess.
		
		call DialogBoxParamA,[Instance],"DLG_CONN",[@hdlg],conn_DlgProc,[@hdlg]
		call GetDlgItem,[@hdlg],IDD_LIST
		mov [hList],eax
		call GetDlgItem,[@hdlg],IDD_REMOTE
		mov [hRemEdit],eax
		call GetDlgItem,[@hdlg],IDD_YOU
		mov [hYouEdit],eax
		call GetDlgItem,[@hdlg],IDD_SEND
		mov [hSendButton],eax
		jmp near returntrue
	endif
	if dword [@uMsg],e,WM_CLOSE
		call MessageBoxA,[@hdlg],"Are you sure?","PE Chat",MB_YESNO
		if eax,e,IDYES
			jmp near byebye
		endif
	endif
	
	if dword [@uMsg],e,WM_EXITINVITE
		call DestroyWindow,[@lparam]
		jmp near returntrue
	endif
	if dword [@uMsg],e,WM_EXITPRIVATE
		call DestroyWindow,[@lparam]
		jmp near returntrue
	endif
	if dword [@uMsg],e,WM_EXITCONF
		call DestroyWindow,[@lparam]
		jmp near returntrue
	endif
	if dword [@uMsg],e,WM_EXITINVITATION
		call DestroyWindow,[@lparam]
		jmp near returntrue
	endif
	
	
	
	if dword [@uMsg],e,WM_CONFINVITATION
		mov edi,[@wparam]
		dec edi
		dec edi
		if dword[@lparam],e,1
			mov word[edi],CONF_INVITATION_CHAIN
		else
			mov word[edi],CONF_INVITATION
		endif
		call	send,[newsockdes],edi,8192,0 
		jmp near returntrue
	endif
	
	if dword [@uMsg],e,WM_CONFJOIN
		;;;;;;call DestroyWindow,[@lparam] already handled in wm_exitinvitation
		call FindWindowA,0,[@wparam]
		if eax,e,0
			mov esi,[@wparam]
			mov edi,SendBuffer
			mov word[edi],JOIN_CONF
			add edi,2
			mov al,1
			while al,ne,0
				lodsb
				stosb
			wend
			call	send,[newsockdes],SendBuffer,8192,0
			call CreateDialogParamA,[Instance],dlg_conf,NULL,conference_DlgProc,[@wparam]
		endif
		mov edi,[@wparam]
		mov byte[edi],0
		jmp near returntrue
	endif
	if dword [@uMsg],e,WM_CONFMESS
		
		call GetWindowTextA,[@wparam],itm1,64
		mov edi,private_sendbuff
		mov word[edi],CONF_MESS
		add edi,2
		mov esi,itm1    ;; copy the conf name and id.
		mov al,1
		while al,ne,0
			lodsb
			stosb
		wend

		mov esi,Theuser
		while byte[esi],ne,0
			movsb
		wend
		mov word[edi],": "
		add edi,2	
		call GetDlgItemTextA,[@wparam],[@lparam],edi,8192   ;; wparam has window handle () and lparam has the edit box of the private chat dialog
		call	send,[newsockdes],private_sendbuff,8192,0							;Send the msg to the server
		if	eax,e,-1							;If eax=-1 then we have an error				
			call	MessageBoxA,[@hdlg],"Couldn't send Message","Error",0	;Apperently we didnt send the message, let's beep!
		endif
		loccall ClearBuffer,private_sendbuff
		jmp near returntrue
	endif
	if dword [@uMsg],e,WM_LEAVECONFMESS
		;;;;;;;;;code to remove user from conference.
		mov edi,[@lparam]
		add edi,2
		xor eax,eax
		mov ecx,-1
		repne scasb
		mov al,'@'
		std
		repne scasb
		cld
		inc edi
		inc edi
		str2int edi
		
		mov edi,SendBuffer
		mov word[edi],LEAVE_CONF
		add edi,2
		mov word[edi],ax
		call	send,[newsockdes],SendBuffer,8192,0 
		jmp near returntrue
	endif
	
	if dword [@uMsg],e,WM_PRIVATEMESS
		;;call MessageBoxA,[@hdlg],"sending mess","hi",0
		call GetDlgItemTextA,[@wparam],[@lparam],private_sendbuff,8192   ;; wparam has window handle () and lparam has the edit box of the private chat dialog
		mov [pri_mess_len],eax
		;;call MessageBoxA,[@hdlg],private_sendbuff,"hi",0

		call GetWindowTextA,[@wparam],itm1,64
		mov ecx,eax
		mov eax,[pri_mess_len]
		inc ecx
		add eax,ecx
		add eax,3
		mov [pri_mess_len],eax
		mov edi,private_sendbuff
		sub edi,ecx
		push edi
		mov esi,itm1    ;; copy the receipient name.
		repnz movsb
		pop edi

		dec edi
		dec edi
		mov word[edi],PRIVATE_MESS
		call	send,[newsockdes],edi,8192,0							;Send the msg to the server
		if	eax,e,-1							;If eax=-1 then we have an error				
			call	MessageBoxA,[@hdlg],"Couldn't send Message","Error",0	;Apperently we didnt send the message, let's beep!
		endif
		loccall ClearBuffer,private_sendbuff
		jmp near returntrue
	endif
	
	if dword [@uMsg],e,WM_COMMAND
		
		if word [@wparam+2],e,LBN_DBLCLK
			call SendMessageA,[hList],LB_GETCURSEL,0,0
					
			if eax,ne,LB_ERR
				call	SendMessageA,[hList],LB_GETTEXT,eax,private_window_title
				call	FindWindowA,"#32770",private_window_title
				if eax,e,0
					call    CreateDialogParamA,[Instance],"DLG_PRIVATE",NULL,private_DlgProc,0
				else
					;call GetClassNameA,eax,itm1,64
					;if byte[itm1],ne,'#'
					;	call    CreateDialogParamA,[Instance],"DLG_PRIVATE",NULL,private_DlgProc,0
					;else
						call SetForegroundWindow,eax
					;endif
					
				endif
			endif
			jmp near returntrue	
		endif
				
		if dword[@wparam],e,IDM_CONN
			call    DialogBoxParamA,[Instance],"DLG_CONN",[@hdlg],conn_DlgProc,[@hdlg]
			jmp near returntrue
		endif

		if dword[@wparam],e,IDM_ABOUT
		        call    DialogBoxParamA,[Instance],"DLG_ABOUT",[@hdlg],About_DlgProc,0
		        jmp near returntrue
		endif
		if dword[@wparam],e,IDD_EXIT
			call MessageBoxA,[@hdlg],"Are you sure?","PE Chat",MB_YESNO
			if eax,e,IDYES
				jmp near byebye
			endif
        	endif
		if dword[@wparam],e,IDM_EXIT
			call MessageBoxA,[@hdlg],"Are you sure?","PE Chat",MB_YESNO
			if eax,e,IDYES
				byebye:

				loccall close_private_windows,[@hdlg]

				mov dword[mainwinhandle],0
				call closesocket,[newsockdes]	;We must close all open sockets
				call closesocket,[sockdes]	;We must close all open sockets
				call WSACleanup			;Let's clean up the mess we created :)
				call    EndDialog,[@hdlg],0
			endif
        		jmp near returntrue
        	endif
       		
	
		if dword [@wparam],e,IDM_CONFINVITE_MAIN	
			call	FindWindowA,0,confinvite
			if eax,e,0
				call CreateDialogParamA,[Instance],dlg_invite,NULL,InviteDlgProc,0
			else
				call SetForegroundWindow,eax
			endif
			jmp near returntrue
		endif
	
       		
       		
       		if dword[@wparam],e,IDD_SEND
			
			call SendDlgItemMessageA,[@hdlg],IDD_YOU,WM_GETTEXT,8192,SendBuffer	;Get the string that we want to send
			test	eax,eax							;Error?
			je near ouch							;If so, exit
			mov ecx,eax
			add eax,[userlen]
			add eax,2   				;;;    for " :" and space 
			push	eax								;Push away the length of the string (we'll need this later)
			mov	edi,SendBuffer					;Offset of the message in EDI
			add	edi,ecx							;Add the length of the string to EDI, thus making it point to the end of the string.
			
			mov	byte  [edi],13				;We must add a LineFeed to it
			inc edi
			mov	byte  [edi],10
			inc edi
			mov byte [edi],0   ;; terminate the string.
			mov edi,SendBuffer
			dec edi
			dec edi
			mov word[edi],": "
			mov eax,[userlen]
			sub edi,eax
			mov [printfromhere],edi
			
			mov esi,Theuser
			mov ecx,[userlen]
			repnz movsb 
			call SendMessageA,[hRemEdit],WM_GETTEXTLENGTH,0,0
			call SendMessageA,[hRemEdit],EM_SETSEL,eax,eax
			call	SendDlgItemMessageA,[@hdlg],IDD_REMOTE,EM_REPLACESEL,0,[printfromhere]
			pop	eax			;Eax = Length of string  ;;;pushed some 23 lines above ..
			call	send,[newsockdes],[printfromhere],eax,0							;Send the msg to the server
			if	eax,e,-1							;If eax=-1 then we have an error				
				call	MessageBoxA,[@hdlg],"Couldn't send Message","Error",0	;Apperently we didnt send the message, let's beep!
			endif
			mov		al,0
			mov		ecx,8192
			mov		edi,SendBuffer
			rep		stosb							;Clear the SendBuffer string
			call	SetDlgItemTextA,[@hdlg],IDD_YOU,SendBuffer
			call SetFocus,[hYouEdit]
			ouch:
			call SetFocus,[hYouEdit]
			mov eax,TRUE
			
		endif
		jmp near returntrue
	endif
	if dword [@uMsg],e,WM_SOCKET
		if word[@lparam],e,FD_CONNECT					;Do we have a FD_CONNECT msg?
			if word[@lparam+2],e,0
				call	SetDlgItemTextA,[@hdlg],IDD_STATUS,Connection
				loccall send_userid_to_server,[newsockdes]		
			else
				call    MessageBoxA,[@hdlg],err2text,err2title,0
				
			endif
			
			jmp near returntrue
		endif
		if word[@lparam],e,FD_READ	
			call	recv,[newsockdes],ReadBuffer,8192,0							;Recieve the text
			mov [textreadlen],eax
			if dword  eax,ne,-1							;If error, then move on
			
				if word[ReadBuffer],e,CONF_INVI_ACK
					mov esi,ReadBuffer
					add esi,2
					mov edi,conf_window_title
					mov al,1
					while al,ne,0
						lodsb
						stosb
					wend
					
					call CreateDialogParamA,[Instance],dlg_conf,NULL,conference_DlgProc,conf_window_title
					
					call GetDlgItem,eax,IDF_YOU
					call EnableWindow,eax,TRUE
					loccall ClearBuffer,ReadBuffer
					jmp near returntrue
				endif
				if word[ReadBuffer],e,CONF_INVITATION_REAL
					mov esi,ReadBuffer+2
					mov edi,invititle
					while byte[esi],ne,0
						movsb		
					wend
					mov esi,invitation
					while byte[esi],ne,0
						lodsb
						stosb
					wend
					mov al,0
					stosb	
					call FindWindowA,0,invititle
					if eax,e,0
						loccall store_confname,pendconf,ReadBuffer+2
						call CreateDialogParamA,[Instance],dlg_invitation,NULL,Invitation_DlgProc,eax
					endif
					loccall ClearBuffer,ReadBuffer
					jmp near returntrue
				endif
				if word[ReadBuffer],e,GET_CONFLIST
					mov edi,ReadBuffer
					inc edi
					inc edi
					push edi
					call	FindWindowA,0,edi
					mov [conf_win_temp],eax
					call GetDlgItem,eax,IDF_LIST
					pop edi
					mov [conf_list_temp],eax
					mov ecx,-1
					xor eax,eax
					repne scasb
					while byte[edi],ne,0
						push edi
						call SendMessageA,[conf_list_temp],LB_ADDSTRING,0,edi
						pop edi
						mov ecx,-1
						xor eax,eax
						repne scasb
					wend
					loccall ClearBuffer,ReadBuffer
					jmp near returntrue
				endif
				if word[ReadBuffer],e,USER_LEFT_CONF
					mov edi,ReadBuffer
					inc edi
					inc edi
					push edi
					call	FindWindowA,0,edi
					mov [conf_win_temp],eax
					call GetDlgItem,[conf_win_temp],IDF_LIST
					pop edi
					mov [conf_list_temp],eax
					mov ecx,-1
					xor eax,eax
					repne scasb
					call SendMessageA,[conf_list_temp],LB_FINDSTRING,0,edi
					call SendMessageA,[conf_list_temp],LB_DELETESTRING,eax,0
					loccall ClearBuffer,ReadBuffer
					jmp near returntrue
				endif
				if word[ReadBuffer],e,USER_JOINED_CONF
					mov edi,ReadBuffer
					inc edi
					inc edi
					push edi
					call	FindWindowA,0,edi
					mov [conf_win_temp],eax
					call GetDlgItem,eax,IDF_LIST
					pop edi
					mov [conf_list_temp],eax
					mov ecx,-1
					xor eax,eax
					repne scasb
					push edi
					call SendMessageA,[conf_list_temp],LB_FINDSTRING,0,edi
					pop edi
					if eax,e,LB_ERR
						call SendMessageA,[conf_list_temp],LB_ADDSTRING,0,edi
					endif
					
					loccall ClearBuffer,ReadBuffer
					jmp near returntrue
				endif
				if word[ReadBuffer],e,CONF_MESS
					
					mov edi,ReadBuffer
					add edi,2
					push edi
					call	FindWindowA,0,edi
					mov [pri_window],eax
					pop edi
					if eax,ne,0
						push edi
						call GetDlgItem,eax,IDF_USEREDIT
						mov [@hPriEdit_ex],eax
						call SendMessageA,[@hPriEdit_ex],WM_GETTEXTLENGTH,0,0
						call SendMessageA,[@hPriEdit_ex],EM_SETSEL,eax,eax
						pop edi
						mov eax,0
						mov ecx,-1 
						repne scasb
						push edi
						call SendDlgItemMessageA,[pri_window],IDF_USEREDIT,EM_REPLACESEL,0,edi
						pop edi
						xor eax,eax
						mov ecx,-1
						repne scasb
						dec edi
						dec edi
						if byte[edi],ne,10
							call SendDlgItemMessageA,[pri_window],IDF_USEREDIT,EM_REPLACESEL,0,nextline
						endif
						call SetForegroundWindow,[pri_window]
					endif
					
					jmp near returntrue
				endif
				
				if word[ReadBuffer],e,LATE_CONF
					call	FindWindowA,0,ReadBuffer+2
					if eax,ne,0
						call DestroyWindow,eax
					endif
					call MessageBoxA,[@hdlg],"You were too late for the conference","PE Chat",0
					jmp near returntrue
				endif
				if word[ReadBuffer],e,YES_CONF
					call	FindWindowA,0,ReadBuffer+2
					if eax,ne,0
						call GetDlgItem,eax,IDF_YOU
						call EnableWindow,eax,TRUE
					else
						call MessageBoxA,[@hdlg],"PEchat","Unexpected conference Error(conference details not in server)",0
					endif
					jmp near returntrue
				endif
				
				if word[ReadBuffer],e,PRIVATE_MESS
					mov esi,ReadBuffer
					add esi,2
					mov edi,private_readbuff
					mov al,1
					while al,ne,0
						lodsb
						stosb
					wend
					dec edi
					mov word[edi],": "
					add edi,2
					mov al,1
					while al,ne,0
						lodsb
						stosb
					wend
					mov edi,ReadBuffer
					add edi,2
					call	FindWindowA,"#32770",edi
					mov [pri_window],eax
					if eax,e,0
					    some_win_samename:
						mov esi,ReadBuffer
						add esi,2
						mov edi,private_window_title
						mov al,1
						while al,ne,0
							lodsb
							stosb
						wend
						call CreateDialogParamA,[Instance],"DLG_PRIVATE",NULL,private_DlgProc,private_readbuff
						
					else
						call GetDlgItem,eax,IDP_USEREDIT
						mov [@hPriEdit_ex],eax
						call SendMessageA,[@hPriEdit_ex],WM_GETTEXTLENGTH,0,0
						call SendMessageA,[@hPriEdit_ex],EM_SETSEL,eax,eax
						
						call SendDlgItemMessageA,[pri_window],IDP_USEREDIT,EM_REPLACESEL,0,private_readbuff
						mov edi,private_readbuff
						xor eax,eax
						mov ecx,-1
						repne scasb
						dec edi
						dec edi
						if byte[edi],ne,10
							call SendDlgItemMessageA,[pri_window],IDP_USEREDIT,EM_REPLACESEL,0,nextline
						endif
						call SetForegroundWindow,[pri_window]
					endif
					jmp near returntrue
				endif
				if word[ReadBuffer],e,USER_ADD
					
					mov edi,ReadBuffer
					inc edi
					inc edi
					call SendMessageA,[hList],LB_ADDSTRING,0,edi
				else
					if word[ReadBuffer],e,GET_USERLIST
						push ecx
						mov edi,ReadBuffer
						inc edi
						inc edi
						xor ecx,ecx
						dec ecx
						while byte[edi],ne,0
							push edi
							call SendMessageA,[hList],LB_ADDSTRING,0,edi
							pop edi
							
							mov ecx,-1
							xor eax,eax
							repne scasb
						wend
						pop ecx
						jmp near returntrue
					endif
					if word[ReadBuffer],e,USER_DEL
						mov edi,ReadBuffer
						inc edi
						inc edi
						call SendMessageA,[hList],LB_FINDSTRING,0,edi
						call SendMessageA,[hList],LB_DELETESTRING,eax,0
						jmp near clearstring
					endif
				
					if word[ReadBuffer],e,USER_REJ
						mov edi,ReadBuffer
						add edi,2
						if byte[edi],e,0
							call MessageBoxA,[@hdlg],"Already connected to server...Exiting...","Request Rejected",MB_OK
						else
							call MessageBoxA,[@hdlg],edi,"PE Chat",0
						endif
						popa
						call ExitProcess,0
					endif
					if word[ReadBuffer],e,0
						jmp near returntrue
					endif
					
					mov		edi,ReadBuffer
					mov ecx,-1
					mov al,0
					repne scasb
					dec edi
					mov		byte  [edi],13				;Add a line feed to the text
					mov		byte  [edi+1],10
					mov 		byte  [edi+2],0
					call SendMessageA,[hRemEdit],WM_GETTEXTLENGTH,0,0
					call SendMessageA,[hRemEdit],EM_SETSEL,eax,eax
					call	SendDlgItemMessageA,[@hdlg],IDD_REMOTE,EM_REPLACESEL,0,ReadBuffer				;Show the message in the "Chat Window"
					
					call SetForegroundWindow,[@hdlg]
				endif
			clearstring:
				mov	eax,0				;Clear the string
				mov	ecx,2048
				mov	edi,ReadBuffer
				rep	stosd
				
			endif
			jmp near returntrue
		endif ;; for fd_read
		
		if word[@lparam],e,FD_CLOSE
			call SendMessageA,[hList],LB_RESETCONTENT,0,0
			call	MessageBoxA,[@hdlg],"Connection to server lost!!","PE chat",0
			
			call closesocket,[newsockdes]	;We must close all open sockets
			call closesocket,[sockdes]	;We must close all open sockets
			call WSACleanup		
			;;;loccall close_private_windows,[@hdlg];
       			
        		call	SetDlgItemTextA,[@hdlg],IDD_STATUS,NotConnected
        		jmp near returntrue
		endif
		
	endif
	returnfalse:
	popa
	return FALSE
	
	returntrue:
	
	popa
	return TRUE
endproc
