%include "nagoa+.inc"

%define DISALLOW_MULTI_CONN 1   ;; commenting this line is not advisable...(allows to connect with same login twice.)

;;%macro API 2                                   ;Function , Library
;;	import %1 %2
;;	extern %1
;;%endmacro

;; i have included the above API macro in my nagoa+.inc


API GetModuleHandleA, kernel32.dll
API RegisterClassExA, user32.dll
API WSAStartup,wsock32.dll
API htons,wsock32.dll
API FindWindowA,user32.dll
API LoadIconA,user32.dll
API CreateWindowExA, user32.dll
API MessageBoxA, user32.dll
API SendDlgItemMessageA,user32.dll
API SendMessageA, user32.dll
API DefWindowProcA, user32.dll
API ExitProcess, kernel32.dll
API GetMessageA, user32.dll
API DispatchMessageA, user32.dll
API TranslateMessage,user32.dll
API accept,wsock32.dll
API SetDlgItemTextA,user32.dll
API recv,wsock32.dll
API send,wsock32.dll
API socket,wsock32.dll
API WSAAsyncSelect,wsock32.dll
API bind,wsock32.dll
API listen,wsock32.dll
API closesocket,wsock32.dll
API WSACleanup,wsock32.dll
API ShowWindow,user32.dll
API UpdateWindow,user32.dll
API GetCommandLineA,kernel32.dll
API PostQuitMessage,user32.dll
API LoadCursorA,user32.dll
;;;;;;;;;;;API wvsprintfA,user32.dll
API inet_addr,wsock32.dll
API GetDlgItem,user32.dll
API IsWindow,user32.dll
API DestroyWindow,user32.dll
%define ACK_CONN 0x0101
%define SEND_USERLIST 0x0102
%define USER_ADDED 0x0103
%define USER_DELETED 0x0104
%define USER_REJ 0x0105
%define PRIVATE_MESS 0x0106
%define CONF_INVITATION 0x0107
%define CONF_INVI_ACK 0X0108
%define CONF_INVITATION_REAL 0X0109
%define CONF_MESS 0x0110
%define JOIN_CONF 0X0111
%define LEAVE_CONF 0X0112
%define SEND_CONFLIST 0X0113
%define USER_JOINED_CONF 0x0114
%define USER_LEFT_CONF 0x0115
%define LATE_CONF 0x0116
%define CONF_INVITATION_CHAIN 0x0117
%define YES_CONF 0x0118
WM_LISTSOCKET EQU WM_USER+100
EDIT_TOTUSER EQU 1000
BUTTON_EXIT EQU 1001
LABEL_TOT EQU 1002
USERLIST_ID EQU 1003
SOCKLIST_ID EQU 1004
BUTTON_DELUSER EQU 1005
segment .data USE32

Windowname db 'PE Chat 1.04a - (Server)',0
CommandLine	dd 0
Windowhandle			dd 0
Instance		dd 0
NoMoreConn db "<<No more connections can be accepted by the server>>.",13,10,0
Windowclassname db "OurWindowclass",0
OurWindowclass:
istruc WNDCLASSEX
	at WNDCLASSEX.cbSize,		dd WNDCLASSEX_size
	at WNDCLASSEX.style,		dd CS_HREDRAW|CS_VREDRAW
	at WNDCLASSEX.lpfnWndProc,	dd WindowProc
      at WNDCLASSEX.hbrBackground,	dd COLOR_BTNFACE+1
      at WNDCLASSEX.lpszClassName,	dd Windowclassname
iend
sin:
istruc sockaddr_in

iend
wsadata:
istruc WSAdata

iend


itm1: times 128 db 0

listsock dd 0
PORT			 dd 49
Connections		 dd 0
Connectionsstr	 db '0',0,0,0,0,0

temp	 dd 0
indexofdel dd 0
LengthOfString	 dd 0
LengthOfIntro dd 0
label_class db "STATIC",0
button_class db "BUTTON",0
list_class db "LISTBOX",0

hUserList dd 0
hSockList dd 0

confstartid dd 5000
testnum db "5000",0
segment .bss USE32
MessageBuffer resb MSG_size
sockstring resb 32
introbuffer resb 8192
noofusers resd 1
sender_len resd 1
towhom resd 1
junklen resd 1
sendjunklen resd 1
templisthandle resd 1
currentconfuser resd 1      ; used for socket descriptor 
noofusers_conf_temp resd 1
itm2 resb 128
itm3 resb 128
ReadBuffer resb 8192
sockdes resb 4000
segment .code USE32
..start:



call GetModuleHandleA, 0
mov dword [Instance], eax

call	WSAStartup,0101h,wsadata
mov	word[sin+sockaddr_in.sin_family], AF_INET

;Convert the PORT
call	htons,[PORT]
mov	word[sin+sockaddr_in.sin_port],ax

;We dont want more than one copy of the server program running
call	FindWindowA,0,Windowname
if eax,ne,0
	call MessageBoxA,0,"Sorry, Already an instance of PE chat is running","PE Chat",0
	jmp near getout
endif
call GetCommandLineA
mov dword [CommandLine], eax
loccall WinMain, [Instance], NULL, eax, SW_SHOW
getout:
call ExitProcess, eax

proc WinMain, hInstance, hPrevInstance, lpCmdLine, nCmdShow
       mov eax, dword [Instance]
       mov dword [OurWindowclass+WNDCLASSEX.hInstance], eax
       call LoadIconA, NULL, IDI_APPLICATION
       mov dword [OurWindowclass+WNDCLASSEX.hIcon], eax
       mov dword [OurWindowclass+WNDCLASSEX.hIconSm], eax
       call LoadCursorA, NULL, IDC_ARROW
       mov dword [OurWindowclass+WNDCLASSEX.hCursor], eax
       call RegisterClassExA,OurWindowclass
       test eax, eax
       jnz .DoAndShow
       return

.DoAndShow:

      ;--- create and show the main program window
	call CreateWindowExA,NULL,Windowclassname,Windowname,WS_OVERLAPPED|WS_VISIBLE|WS_CAPTION|WS_MINIMIZEBOX |WS_SYSMENU,200,300,480,280, NULL, NULL, [Instance], NULL
	mov dword [Windowhandle], eax
	call ShowWindow, [Windowhandle], [@nCmdShow]
	call UpdateWindow,[Windowhandle]

; -- every time user moves mouse or imput some msg this loop is activated
; -- in order to get all messages imputed by the user
.loop
	call GetMessageA,MessageBuffer, NULL, 0, 0
	cmp eax, 0
	jb .erro
	je .fin
	call TranslateMessage,MessageBuffer
	call DispatchMessageA,MessageBuffer
	jmp .loop
	.erro:
	call MessageBoxA, 0, "ERROR", "Sorry ...", MB_OK
	.fin:
	mov eax, dword[MessageBuffer+MSG.wParam]
endproc
proc WindowProc,hwnd,uMsg,wParam,lParam
	mov eax, dword [@uMsg]
	if eax,e,WM_DESTROY
		call PostQuitMessage, 0
		xor eax,eax
	endif
	if eax,e,WM_CREATE
		call CreateWindowExA,NULL,label_class,"Total users",WS_CHILD |WS_VISIBLE,10,20,80,20,[@hwnd],LABEL_TOT,[Instance],NULL
		call CreateWindowExA, WS_EX_CLIENTEDGE,"EDIT",NULL,WS_VISIBLE|WS_CHILD|ES_AUTOHSCROLL|ES_READONLY,90,20,75,20,[@hwnd],EDIT_TOTUSER,[Instance], NULL
		;mov [hTitleEdit],eax
		call CreateWindowExA,NULL,button_class,"Exit",WS_CHILD |WS_TABSTOP|WS_VISIBLE|BS_PUSHBUTTON,80,110,50,30,[@hwnd],BUTTON_EXIT ,[Instance],NULL
		call CreateWindowExA,NULL,button_class,"Del User",WS_CHILD |WS_TABSTOP|WS_VISIBLE|BS_PUSHBUTTON,140,110,80,30,[@hwnd],BUTTON_DELUSER ,[Instance],NULL
		call CreateWindowExA, WS_EX_CLIENTEDGE,list_class,0, WS_HSCROLL|WS_VSCROLL|WS_VISIBLE|WS_BORDER|WS_CHILD|LBS_HASSTRINGS|LBS_NOTIFY,200,10,150,100,[@hwnd], USERLIST_ID, [Instance], NULL 
		mov [hUserList],eax
		call CreateWindowExA, WS_EX_CLIENTEDGE,list_class,0, WS_HSCROLL|WS_VSCROLL|WS_VISIBLE|WS_BORDER|WS_CHILD|LBS_HASSTRINGS|LBS_NOTIFY,360,10,100,100,[@hwnd], SOCKLIST_ID, [Instance], NULL 
		mov [hSockList],eax
		;Create the socket that will listen for incoming connections
		call	socket,PF_INET,SOCK_STREAM,0
		mov [listsock],eax
		;The msg's we want to respond on
		call	WSAAsyncSelect,[listsock],[@hwnd],WM_LISTSOCKET,FD_ACCEPT+FD_READ+FD_CLOSE
		;We must bind this socket in order to use if for listening purposes
		call	bind,[listsock],sin,16
		call	listen,[listsock],100
		call	SetDlgItemTextA,[@hwnd],EDIT_TOTUSER,Connectionsstr
	endif
	if dword [@uMsg],e,WM_COMMAND
		if word [@wParam],e,BUTTON_EXIT
			call MessageBoxA,[@hwnd],"Are you sure?","PE Chat",MB_YESNO
			if eax,e,IDYES
				call	closesocket,[listsock]
				mov	edi,sockdes						;Close all the connected sockets as well
			CheckOpenSockets:
				cmp dword[edi],0
				je	ClosedAllSockets
				call	closesocket,edi
				add	edi,4
				jmp	CheckOpenSockets
			ClosedAllSockets:
				call	WSACleanup						;Clean up the mess we created
				call ExitProcess,0				; get out
			endif
		endif
		if word [@wParam],e,BUTTON_DELUSER
			call SendMessageA,[hUserList],LB_GETCURSEL,0,0
			call SendMessageA,[hSockList],LB_GETTEXT,eax,itm1
			str2int itm1
			mov ebx,eax
			jmp near ExitByServer

		endif
		jmp near mess_pro_done
	endif
	if dword [@uMsg],e,WM_LISTSOCKET
		if word [@lParam],e,FD_ACCEPT
			mov eax,[@lParam]
			shr	eax,16
			call	accept,[listsock],0,0			;Accept the connection,,,,
			
			push eax
			inc	dword[Connections]
			loccall CheckSocketList,0xffffffff	;Find the next empty spot in our SocketHandle array to save away this new SocketHandle
			if eax,e,-1
			loccall CheckSocketList,0
			endif
			pop eax
			mov	[edi],eax
			mov eax,[Connections]
			int2str eax,Connectionsstr
			call	SetDlgItemTextA,[@hwnd],EDIT_TOTUSER,Connectionsstr
			
		endif
		if word [@lParam],e,FD_READ
			
			mov		eax,[@wParam]
			xor		ebx,ebx
			mov		bx,ax
			mov		dword[temp],ebx 					;temp holds the SocketHandle of the Client program we're recieving from
			call	recv,ebx,ReadBuffer,8192,0
			if eax,ne,-1
				mov [junklen],eax
						
				if word[ReadBuffer],e,0x0001
					mov edx,ReadBuffer
					mov word[edx],0x0005
					inc edx
					inc edx
					mov byte[edx],0
					call    send,[temp], "<<Old Version...Exiting>>",25,0
					call	send,[temp],ReadBuffer,8192,0
					call	closesocket,[temp]
					dec	dword [Connections]
					mov eax,[Connections]
					int2str eax,Connectionsstr
					call	SetDlgItemTextA,[@hwnd],EDIT_TOTUSER,Connectionsstr
					loccall ClearBuffer,ReadBuffer
					jmp near mess_pro_done
				endif
				if word[ReadBuffer],e,CONF_INVITATION_CHAIN
									
					mov esi,ReadBuffer
					add esi,2
					mov edi,introbuffer
					mov word[edi],CONF_INVITATION_REAL
					add edi,2
					mov al,1
					while al,ne,0
						lodsb
						stosb
					wend
					mov edi,esi
					
					while byte[edi],ne,0
						push edi
						call SendMessageA,[hUserList],LB_FINDSTRING,0,edi
						if eax,ne,LB_ERR
							call SendMessageA,[hSockList],LB_GETTEXT,eax,itm1
							str2int itm1
							call send,eax,introbuffer,8192,0
						endif
						pop edi
						xor eax,eax
						mov ecx,-1
						repne scasb
					wend
					loccall ClearBuffer,introbuffer
					jmp near mess_pro_done
				endif
				
				if word[ReadBuffer],e,CONF_INVITATION
					mov esi,ReadBuffer
					add esi,2
					mov edi,introbuffer
					mov word[edi],CONF_INVITATION_REAL
					add edi,2
					mov al,1
					while al,ne,0
						lodsb
						stosb
					wend
					dec edi
					mov al,'@'
					stosb
					
					int2str [confstartid],itm1
					mov esi,itm1
					mov al,1
					while al,ne,0
						lodsb
						stosb
					wend
					call CreateWindowExA, WS_EX_CLIENTEDGE,"LISTBOX",0, WS_HSCROLL|WS_VSCROLL|WS_VISIBLE|WS_BORDER|WS_CHILD|LBS_HASSTRINGS|LBS_EXTENDEDSEL|LBS_NOTIFY,10,180,200,90,[@hwnd],[confstartid], [OurWindowclass+WNDCLASSEX.hInstance], NULL 
					mov [templisthandle],eax
					mov edx,introbuffer
					add edx,2
					call SendMessageA,[templisthandle],LB_ADDSTRING,0,edx
					
					mov edi,ReadBuffer
					add edi,2
					push edi
					call SendMessageA,[templisthandle],LB_ADDSTRING,0,edi ; initially add only the starter's name
					pop edi
					xor edx,edx
					while byte[edi],ne,0
						
						push edi
						if edx,g,0
							push edx
							call SendMessageA,[hUserList],LB_FINDSTRING,0,edi
							if eax,ne,LB_ERR
								call SendMessageA,[hSockList],LB_GETTEXT,eax,itm1
								str2int itm1
								call send,eax,introbuffer,8192,0
							endif
							pop edx
						endif
						inc edx
						
						pop edi
						xor eax,eax
						mov ecx,-1
						repne scasb
					wend
					
					inc dword[confstartid]
					mov word[introbuffer],CONF_INVI_ACK									
					call send,[temp],introbuffer,8192,0
					loccall ClearBuffer,introbuffer
					jmp near mess_pro_done
				endif
				if word[ReadBuffer],e,CONF_MESS
					;;;ACCESS THE CONFERENCE LISTBOXES AND SEND TO AUTHENTIC USERS
					mov edi,ReadBuffer
					add edi,2
					mov ecx,-1
					mov al,0
					repne scasb
					while al,ne,'@'
						mov al,[edi]
						dec edi
					wend
					add edi,2
					str2int edi
					
					call GetDlgItem,[@hwnd],eax
					mov [templisthandle],eax
					
					mov ecx,1
					while eax,e,eax
						push ecx
						call SendMessageA,[templisthandle],LB_GETTEXT,ecx,itm1
						if eax,e,LB_ERR
							jmp near out_of_infinite_loop
						endif
						call SendMessageA,[hUserList],LB_FINDSTRING,0,itm1
						if eax,ne,LB_ERR
							call SendMessageA,[hSockList],LB_GETTEXT,eax,itm1
							str2int itm1
							if eax,ne,[temp]
								call send,eax,ReadBuffer,8192,0
							endif
						endif					
						pop ecx
						inc ecx
						
					wend
				out_of_infinite_loop:
					loccall ClearBuffer,ReadBuffer
					jmp near mess_pro_done
				endif
				if word[ReadBuffer],e,JOIN_CONF
					int2str [temp],itm3
					call SendMessageA,[hSockList],LB_FINDSTRING,0,itm3
					call SendMessageA,[hUserList],LB_GETTEXT,eax,itm3
					mov edi,ReadBuffer
					add edi,2
					mov ecx,-1
					mov al,0
					repne scasb
					while al,ne,'@'
						mov al,[edi]
						dec edi
					wend
					add edi,2
					str2int edi
					call GetDlgItem,[@hwnd],eax
					if eax,ne,0
						mov [templisthandle],eax
						mov edi,ReadBuffer
						mov word[edi],YES_CONF
						call send,[temp],ReadBuffer,8192,0
						loccall ClearBuffer,ReadBuffer
					else
						mov edi,ReadBuffer
						mov word[edi],LATE_CONF
						call send,[temp],ReadBuffer,8192,0
						loccall ClearBuffer,ReadBuffer
						jmp near mess_pro_done
					endif
					
					call SendMessageA,[templisthandle],LB_GETCOUNT,0,0
					mov [noofusers_conf_temp],eax
					mov edi,introbuffer
					mov word[edi],SEND_CONFLIST
					add edi,2
					xor ecx,ecx
					while ecx,l,[noofusers_conf_temp]
						push ecx         ;;; -- save counter..
						push edi
						call SendMessageA,[templisthandle],LB_GETTEXT,ecx,itm1
						pop edi
						pop ecx        
						if ecx,g,0      ;;; -- some operations with counter
							pusha
							call SendMessageA,[hUserList],LB_FINDSTRING,0,itm1
							call SendMessageA,[hSockList],LB_GETTEXT,eax,itm2
							str2int itm2
							mov [currentconfuser],eax
							mov edi,ReadBuffer
							mov word[edi],USER_JOINED_CONF
							add edi,2
							push edi
							call SendMessageA,[templisthandle],LB_GETTEXT,0,itm2  ;; itm2 is now free..
							pop edi
														
							mov esi,itm2
							mov al,1
							while al,ne,0
								lodsb
								stosb
							wend
							
							mov esi,itm3
							mov al,1
							while al,ne,0
								lodsb
								stosb
							wend
							call send,[currentconfuser],ReadBuffer,8192,0
							
							popa
						endif
						push ecx						
						mov esi,itm1
						mov al,1
						
						while al,ne,0
							lodsb
							stosb
						wend
						pop ecx
						inc ecx
					wend
					mov al,0
					stosb
					call	send,[temp],introbuffer,8192,0
									
					call SendMessageA,[templisthandle],LB_ADDSTRING,0,itm3; add the joining user in conf list box
					loccall ClearBuffer,introbuffer
					loccall ClearBuffer,ReadBuffer
					jmp near mess_pro_done
				endif
				if word[ReadBuffer],e,LEAVE_CONF
					
					int2str [temp],itm3
					call SendMessageA,[hSockList],LB_FINDSTRING,0,itm3
					call SendMessageA,[hUserList],LB_GETTEXT,eax,itm3
					mov edi, ReadBuffer
					add edi,2
					xor eax,eax
					mov ax,[edi]
					call GetDlgItem,[@hwnd],eax
					mov [templisthandle],eax
									
					call SendMessageA,[templisthandle],LB_FINDSTRING,0,itm3
					call SendMessageA,[templisthandle],LB_DELETESTRING,eax,0 ; del the user in conf list box
					
					;; inform other users...
					call SendMessageA,[templisthandle],LB_GETCOUNT,0,0
					mov [noofusers_conf_temp],eax
					
					call SendMessageA,[templisthandle],LB_GETTEXT,0,itm2  ;; itm2 is now free..
					mov edi,ReadBuffer
					mov word[edi],USER_LEFT_CONF
					add edi,2

					mov esi,itm2
					mov al,1
					while al,ne,0
						lodsb
						stosb
					wend					
					mov ecx,1
					if dword[noofusers_conf_temp],e,1
						call DestroyWindow,[templisthandle]
						jmp near mess_pro_done
					endif
					
					while ecx,l,[noofusers_conf_temp]
						push ecx         ;;; -- save counter..
						push edi         ;;; save our positions
						call SendMessageA,[templisthandle],LB_GETTEXT,ecx,itm1
						call SendMessageA,[hUserList],LB_FINDSTRING,0,itm1
						call SendMessageA,[hSockList],LB_GETTEXT,eax,itm2
						str2int itm2
						mov [currentconfuser],eax

						pop edi  ;; here comes the position where we have to add the user who has left..
						mov esi,itm3
						mov al,1
						while al,ne,0
							lodsb
							stosb
						wend
						call send,[currentconfuser],ReadBuffer,8192,0
						
						pop ecx
						inc ecx
					wend
					loccall ClearBuffer,ReadBuffer
					jmp near mess_pro_done
				endif
				
				if word[ReadBuffer],e,PRIVATE_MESS
					mov edi,ReadBuffer
					add edi,2
					call SendMessageA,[hUserList],LB_FINDSTRING,0,edi
					
					if eax,ne,LB_ERR  ;;for message for offline user sent to unintended recepient.
						call SendMessageA,[hSockList],LB_GETTEXT,eax,itm1
						str2int itm1
						mov [towhom],eax
					else
						mov dword[towhom],0
					endif
					
					int2str [temp],itm1
					call SendMessageA,[hSockList],LB_FINDSTRING,0,itm1
					call SendMessageA,[hUserList],LB_GETTEXT,eax,itm1
					
					mov [sender_len],eax
					mov edi,ReadBuffer
					add edi,2
					mov al,0
					mov ecx,-1
					
					repne scasb
					not ecx
					dec ecx
					mov eax,[junklen]
					sub eax,ecx
					add eax,[sender_len]
					add eax,2
					mov [sendjunklen],eax
					
					sub edi,[sender_len]
					sub edi,1
					push edi				
					mov esi,itm1
					mov ecx,[sender_len]
					repne movsb
					pop edi
					
					sub edi,2
					mov word[edi],PRIVATE_MESS
					
					call send,[towhom],edi,8192,0
					
					loccall ClearBuffer,ReadBuffer
					jmp near mess_pro_done
				endif
				
				if word[ReadBuffer],e,ACK_CONN
					pusha
					if dword[Connections],g,500
						mov edi,introbuffer
						mov esi,NoMoreConn
						mov al,1
						while al,ne,0
							lodsb
							stosb
						wend
						mov		eax,[@wParam]
						xor		ebx,ebx
						mov		bx,ax
						mov		dword[temp],ebx 	
						call send,[temp],introbuffer,8192,0
						call	closesocket,[temp]
						dec	dword [Connections]
						mov eax,[Connections]
						int2str eax,Connectionsstr
						call	SetDlgItemTextA,[@hwnd],EDIT_TOTUSER,Connectionsstr
						loccall ClearBuffer,ReadBuffer
						
						popa
						jmp near mess_pro_done
					endif
					popa
					mov edi,ReadBuffer
					inc edi
					inc edi
					call SendMessageA,[hUserList],LB_FINDSTRING,0,edi
					%ifdef DISALLOW_MULTI_CONN
					
					if eax,e,LB_ERR
					
					%endif
						call SendMessageA,[hUserList],LB_GETCOUNT,0,0
						mov [noofusers],eax
						xor ecx,ecx
						mov edi,introbuffer
						mov word[edi],SEND_USERLIST
						inc edi
						inc edi
						if dword[noofusers],e,0
							jmp near firstuser
						endif
						while ecx,l,[noofusers]
							push ecx
							push edi
							call SendMessageA,[hUserList],LB_GETTEXT,ecx,itm1
							pop edi
							mov esi,itm1
							while byte[esi],ne,0
								movsb
							wend
							mov al,0
							stosb
							pop ecx
							inc ecx
						wend
						mov al,0
						stosb
						
						call	send,[temp],introbuffer,8192,0
						loccall ClearBuffer,introbuffer
					firstuser:
						mov edi,ReadBuffer
						inc edi
						inc edi
						call SendMessageA,[hUserList],LB_ADDSTRING,0,edi
						int2str [temp],sockstring
						call SendMessageA,[hSockList],LB_ADDSTRING,0,sockstring
						mov word[ReadBuffer],USER_ADDED
					%ifdef DISALLOW_MULTI_CONN
					else
						;;;;;user  is rejected.
						mov edx,ReadBuffer
						mov word[edx],USER_REJ
						inc edx
						inc edx
						mov byte[edx],0
						call	send,[temp],ReadBuffer,8192,0
						call	closesocket,[temp]
						dec	dword [Connections]
						mov eax,[Connections]
						int2str eax,Connectionsstr
						call	SetDlgItemTextA,[@hwnd],EDIT_TOTUSER,Connectionsstr
						loccall ClearBuffer,ReadBuffer
						jmp near mess_pro_done
					endif
					
					%endif
				endif
							
				mov eax,[junklen]
				mov		edi,sockdes						;Edi points to the array of connected SocketHandles.
				mov		[LengthOfString],eax
				mov		ebx,[temp]
			SendMore:
				if dword[edi],ne,ebx				;Is this the SocketHandle we got the info from?
					if dword[edi],ne,0xffffffff	    ; already used and haunted space
						jmp PerhapsSend
					endif
				endif
					;If not, continue
				add		edi,4							;Dont send the string to the SocketHandle we got it from
				jmp		SendMore
			PerhapsSend:
				cmp		dword [edi],0				;Have we processed all the SocketHandle's`?
				je		Senteverything					;If so, then we're done
						;Else, send the string to the SocketHandle that EDI points to
				push ebx
				call	send,[edi],ReadBuffer,8192,0
				pop ebx
				add		edi,4
				jmp		SendMore
			Senteverything:
				loccall ClearBuffer,ReadBuffer
				
			endif
		endif
		if word [@lParam],e,FD_CLOSE	;FD_CLOSE msg?
		 
			mov		eax,[@wParam]
			xor		ebx,ebx
			mov		bx,ax
		ExitByServer:     ;;;server manually exiting the user..
			mov [temp],ebx
			loccall CheckSocketList,ebx					;Get where in the SocketHandle array the current Handle is.
			mov		dword [edi],0xffffffff				;Remove it from the list!
	
			int2str [temp],sockstring
			
			call SendMessageA,[hSockList],LB_FINDSTRING,0,sockstring
			if eax,ne,LB_ERR
				pusha
				loccall RemoveUserFromConfs,sockstring,[@hwnd]
				popa
				mov [indexofdel],eax
				mov edi,ReadBuffer
				mov word[edi],USER_DELETED
				inc edi
				inc edi
				
				call SendMessageA,[hUserList],LB_GETTEXT,[indexofdel],itm1
				mov ecx,eax
				mov esi,itm1
				repnz movsb
				xor eax,eax
				stosb
				call SendMessageA,[hSockList],LB_DELETESTRING,[indexofdel],0
				
				call SendMessageA,[hUserList],LB_DELETESTRING,[indexofdel],0
			endif
			
			mov	edi,sockdes						;Edi points to the array of connected SocketHandles.
			mov	ebx,[temp]
		SendMoredel:
			if dword[edi],ne,ebx				;Is this the SocketHandle we got the info from?
				if dword[edi],ne,0xffffffff	    ; already used and haunted space
					jmp PerhapsSenddel
				endif
			endif
				;If not, continue
			add	edi,4							;Dont send the string to the SocketHandle we got it from
			jmp	SendMoredel
		PerhapsSenddel:
			cmp	dword [edi],0				;Have we processed all the SocketHandle's`?
			je	Senteverythingdel				;If so, then we're done
					;Else, send the string to the SocketHandle that EDI points to
			call	send,[edi],ReadBuffer,8192,0
			add	edi,4
			jmp	SendMoredel
		Senteverythingdel:
			mov	al,0							;Clear the string
			mov	ecx,8192
			mov	edi,ReadBuffer
			rep	stosb
		
		;Close down the socket
			call	closesocket,[temp]
			dec	dword [Connections]
			mov eax,[Connections]
			int2str eax,Connectionsstr
			call	SetDlgItemTextA,[@hwnd],EDIT_TOTUSER,Connectionsstr
		endif
		
	endif	     ; for (wm_listsocket)

defaultaction:
	call DefWindowProcA, [@hwnd], [@uMsg], [@wParam], [@lParam]
mess_pro_done:
	return


endproc
proc CheckSocketList,value
		mov eax,[@value]
		mov edi,sockdes
		sub edi,4
		mov ecx,999
	CheckMoreSocket:
		add	edi,4
		if eax,ne,dword[edi]
			dec ecx
			if ecx,e,0
				mov eax,-1
				jmp returnback4
			endif
			jmp CheckMoreSocket
		endif
returnback4:
endproc

proc ClearBuffer,buffer
			mov	eax,0							;Clear the string
			mov	ecx,2048
			mov	edi,[@buffer]
			rep	stosd
endproc

proc RemoveUserFromConfs,socktobedel,par_window
	call SendMessageA,[hSockList],LB_FINDSTRING,0,[@socktobedel]
	call SendMessageA,[hUserList],LB_GETTEXT,eax,itm1
	mov ecx,5000
	
	while ecx,l,[confstartid]
		push ecx
		call GetDlgItem,[@par_window],ecx
		if eax,ne,0
			mov [templisthandle],eax
			call SendMessageA,eax,LB_FINDSTRING,0,itm1
			if eax,ne,LB_ERR
				call SendMessageA,[templisthandle],LB_DELETESTRING,eax,0
				call SendMessageA,[templisthandle],LB_GETCOUNT,0,0
				if eax,e,1
					call DestroyWindow,[templisthandle]
				endif
			endif
		endif
		pop ecx
		inc ecx
	wend

endproc


;;; get the user ids as soon as  they connect with the server
;;; 
;;read buffer and if word 0x0101 is found then accept their id..

;;; Send details of online users: 0x0102 ,


	;;eg 0x0102 , juju_vv   0x00  momo_kk   0x00 lk_vek   0x00,0x00
	
	;;This message is sent to only one client at the time of connection
	
	
;;;; new user notification 0x0103 ,"momo_kk",0           ;; sent to all but the one who came in..


;;;  user leaving conference 0x0104 , "momo_kk",0         ;; sent  to all but the one who left..

;; send user rejection command 0x0105, 0 ;; send to only one client

;; accept 0x0106 and find the socket descriptor corresponding to the recepient and send the 0x0106 sender name,message.

;; accept 0x0107 and create the listbox for that conference by adding the conf name as first element and creator as second element.

;; send 0x0108 to the user who started the conf along with the conf name.

;; send 0x0109 with the conf name.(this is the actual invitation for a particular conf.

;; send and receive 0x0110 with the confname and message.

;; accept 0x0111 and add the user id to the listbox corresponding to the conference.

;; accept 0x0112 and delete the user id from the listbox corresponding to the conference.

;; send 0x0113 with the user ids of the users who are already present in a particular conference.

;; send 0x0114 to the users (except the newly joined user) with the newly joined user id in a particular conference.

;; send 0x0115 to the users (except the user who left ) with the user id who just left from  a particular conference.

;; send 0x0116 to the user who has joined a conference which doesnt have the listbox in the serv.

;; accept 0x0117 and send the invitation to the users for which the user has requested to send...(when invited from a conference dialog)

;; send 0x0118 to the user (indicating that his conference init was successful.


;;; for easy reference...

;;	ACK_CONN 		0x0101
;;	SEND_USERLIST 		0x0102
;;	USER_ADDED		0x0103
;;	USER_DELETED 		0x0104
;;	USER_REJ 		0x0105
;;	PRIVATE_MESS 		0x0106
;;	CONF_INVITATION 	0x0107
;;	CONF_INVI_ACK 		0X0108
;;	CONF_INVITATION_REAL 	0X0109
;;	CONF_MESS 		0x0110
;;	JOIN_CONF 		0X0111
;;	LEAVE_CONF 		0X0112
;;	SEND_CONFLIST 		0X0113
;;	USER_JOINED_CONF 	0x0114
;;	USER_LEFT_CONF 		0x0115
;;	LATE_CONF 		0x0116
;;	CONF_INVITATION_CHAIN 	0x0117
;;	YES_CONF 		0x0118