%include "nagoa+.inc"

;;%define OWNLOGIN 1  ;; Uncomment this when testing this in same machine (cannot test conferences)..


;;%macro API 2                                   ;Function , Library
;;	import %1 %2
;;	extern %1
;;%endmacro

;; i have included the above API macro in my nagoa+.inc

API RegOpenKeyExA,advapi32.dll
API RegQueryValueExA,advapi32.dll
API RegCloseKey,advapi32.dll
API GetClassNameA,user32.dll
API GetParent,user32.dll
API SetWindowPos,user32.dll
API GetWindowRect, user32.dll
API GetModuleHandleA, kernel32.dll
API RegisterClassExA, user32.dll
API WSAGetLastError,wsock32.dll
API WSAStartup,wsock32.dll
API GetDlgItemInt,user32.dll
API EnableWindow,user32.dll
API htons,wsock32.dll
API FindWindowA,user32.dll
API LoadIconA,user32.dll
API CreateWindowExA, user32.dll
API MessageBoxA, user32.dll
API SendDlgItemMessageA,user32.dll
API SendMessageA, user32.dll
API DefWindowProcA, user32.dll
API ExitProcess, kernel32.dll
API GetMessageA, user32.dll
API DispatchMessageA, user32.dll
API SetWindowTextA,user32.dll
API TranslateMessage,user32.dll
API accept,wsock32.dll
API SetDlgItemTextA,user32.dll
API recv,wsock32.dll
API send,wsock32.dll
API socket,wsock32.dll
API WSAAsyncSelect,wsock32.dll
API bind,wsock32.dll
API DestroyWindow,user32.dll
API listen,wsock32.dll
API closesocket,wsock32.dll
API WSACleanup,wsock32.dll
API ShowWindow,user32.dll
API UpdateWindow,user32.dll
API GetCommandLineA,kernel32.dll
API PostQuitMessage,user32.dll
API LoadCursorA,user32.dll
API DialogBoxParamA,user32.dll
API EndDialog,user32.dll
API GetDlgItemTextA,user32.dll
API MessageBeep,user32.dll
API inet_addr,wsock32.dll
API connect,wsock32.dll
API LoadMenuA,user32.dll
API SetMenu,user32.dll
API GetUserNameA,advapi32.dll
API GetDlgItem,user32.dll
API GetWindowTextA,user32.dll
API SetFocus,user32.dll
API CreateDialogParamA,user32.dll
;;API BringWindowToTop,user32.dll
API SetForegroundWindow,user32.dll
API FlashWindow,user32.dll
WM_SOCKET   equ WM_USER+100
WM_PRIVATEMESS equ WM_USER+111
WM_CONFINVITATION equ WM_USER+112
WM_CONFMESS equ WM_USER+113
WM_LEAVECONFMESS equ WM_USER+114
WM_CONFJOIN equ WM_USER+115
WM_EXITINVITE equ WM_USER+116
WM_EXITPRIVATE equ WM_USER+117
WM_EXITCONF equ WM_USER+118
WM_EXITINVITATION equ WM_USER+119


;;;; control words definition..

%define ACK_CONN 0x0101              ;; send the userid we are logged in.
%define GET_USERLIST 0x0102          ;; The buffer contains online users.
%define USER_ADD 0x0103              ;; The buffer contains the newly joined user's id.
%define USER_DEL 0x0104              ;; The buffer contains the user id who just went offline.
%define USER_REJ 0x0105              ;; The user has been rejected ( due to multiple connect from diff machines)
%define PRIVATE_MESS 0x0106          ;; The buffer contains a private message from a specified user.
%define CONF_INVITATION 0x0107       ;; Send Invitation to online users for a conference.
%define CONF_INVI_ACK 0X0108         ;; Invitation is sent to other users by the server.Also tells us the conference name.
%define CONF_INVITATION_REAL 0X0109  ;; The buffer contains the name of the conference.
%define CONF_MESS 0x0110             ;; The buffer contains conference message for a particular conference.
%define JOIN_CONF 0X0111             ;; Accepted invitation for a particular conference..
%define LEAVE_CONF 0X0112            ;; User decides to leave conferene.
%define GET_CONFLIST 0X0113          ;; Received after joining conference.Buffer contains user ids of users who are already in a particular conference.
%define USER_JOINED_CONF 0x0114      ;; A user has joined the conference.The buffer contains that user id..
%define USER_LEFT_CONF 0x0115        ;; A user has left a particular conference.The buffer contains that user id..
%define LATE_CONF 0x0116             ;; All users have left the conference before the user joined.
%define CONF_INVITATION_CHAIN 0x0117  ;; Sent when the user invites through an existing conference.
%define YES_CONF 0x0118               ;; conference init successful.

IDD_EXIT	 EQU 1001
IDD_YOU		 EQU 1002
IDD_REMOTE   EQU 1003
IDD_SEND	 EQU 1004
IDD_CONNECT  EQU 1005
IDD_CANCEL   EQU 1006
IDD_STATUS	 EQU 1007
IDD_LIST	EQU 1008	

;IDD_CHECK    EQU 1009

IDI_ICON1    EQU 100
IDD_IPEDIT   EQU 1103
IDD_ABOUTOK	 EQU 1100
IDU_ENTER EQU 1405
IDU_CANCEL EQU 1406
IDU_USEREDIT EQU 1403
IDM_CONN     EQU 1200
IDM_USERINFO EQU 1201
IDM_ABOUT    EQU 1202
IDM_EXIT     EQU 1203
IDM_CONFINVITE_MAIN equ 1204

;;private items

IDP_SEND equ 1024
IDP_YOU equ 1022
IDP_USEREDIT equ 1023

IDM_PRIVATEEXIT equ 1300


IDI_INVITELIST equ 1050
IDI_INVITE equ 1051
IDI_CANCEL equ 1052

IDM_CONFEXIT equ 1400
IDM_CONFINVITE equ 1401

IDF_YOU equ 1060
IDF_SEND equ 1061
IDF_USEREDIT equ 1062
IDF_LIST equ 1063
IDF_LEAVE equ 1064

IDIN_CONFNAME equ 1071
IDIN_JOIN equ 1072
IDIN_DECLINE equ 1073

segment .data USE32
regqueryvaluesize dd 32
regvaluetype dd 0
issuccess dd 0
dlg_start        db 'DLG_START',0
dlg_about		 db 'DLG_ABOUT',0
dlg_conn		 db 'DLG_CONN',0
dlg_invite	db 'DLG_INVITE',0
dlg_conf 	db 'DLG_CONF',0
dlg_invitation db 'DLG_INVITATION',0

Windowname db 'PE Chat 1.04b - (client) - '
Theuser: times 64 db 0 
confinvite db "PE Chat conference invitation",0
invitation db " - invitation",0

CommandLine	dd 0
Instance        	dd 0

sin:
istruc sockaddr_in

iend
wsadata:
istruc WSAdata

iend

windowpos:

istruc RECT

iend

itm1: times 128 db 0
sockdes			 dd 0
newsockdes		 dd 0
TheIP: times 16 db 0
PORT			 dd 49
userlen dd 256
indexofdel dd 0

ServDowntitle	 db 'Connection lost!',0
ServDowntext	 db 'Connection to server lost, exiting!',0
err2title	 db 'No connection!',0
err2text	 db 'Could not establish connection!',0
conntitle	 db 'Connection!',0
conntext	 db 'Connection established!',0

NotConnected     db '          Not Connected',0
Connection	 db '            Connected',0

CrueStr     	 db ' Welcome to PE Chat! ',13,10,13,10,0

label_class db "STATIC",0
button_class db "BUTTON",0
menu db "mymenu",0
printfromhere dd 0
mainwinhandle dd 0

hList dd 0
hRemEdit dd 0
hYouEdit dd 0
nextline db 13,10,0

segment .bss USE32
noofusers resd 1
MessageBuffer resb MSG_size
ReadBuffer resb 8192
roomforintro resb 8192
private_window_title resb 128
conf_window_title resb 128
private_recepient_space resb 64
private_sendbuff resb 8192
forname resb 32
SendBuffer resb 8192
private_readbuff resb 8192
pri_mess_len resd 1
pri_mess_start resd 1
pri_window resd 1
junkbuffer resb 128
confinvitelist resb 8192
pendconf resb 128*50
selitems_invite resb 2048
hInviteList resd 1
conf_list_temp resd 1
invite_mode resd 1
conf_win_temp resd 1
hSendButton resd 1
textreadlen resd 1
reghandle resd 1
invititle resb 128
segment .code USE32
..start:

call GetModuleHandleA, 0
mov dword [Instance], eax

%IFDEF OWNLOGIN
call DialogBoxParamA,[Instance],dlg_start,0,UserDlgProc,0
%ELSE
call GetUserNameA,Theuser,userlen
;int2str [userlen],itm1
;call MessageBoxA,0,itm1,"hi",0
dec dword[userlen]
%ENDIF
call FindWindowA,"#32770",Windowname
if eax,ne,0
	call MessageBoxA,NULL,"PEChat (client) is already running.","PEChat",MB_OK
	call ExitProcess,0
endif
mov edi,Theuser
if dword[edi],e,"Admi"
	add edi,4
	if dword[edi],e,"nist"
		add edi,4
		if dword[edi],e,"rato"
			add edi,4
			if byte[edi],e,'r'
				inc edi
				if byte[edi],e,0
					call MessageBoxA,NULL,"Sorry! Cannot login with Adminstrator id","PEChat",MB_OK
					call ExitProcess,0
				endif
			endif
		endif
	endif
endif

call DialogBoxParamA,[Instance],1000,0,MainDlgProc,0

getout:
call ExitProcess, eax


%include "client_maindlgproc.inc"       

%include "client_aboutdlgproc.inc"

%include "client_connectiondlgproc.inc"

%include "client_privatedlgproc.inc"

%include "client_invitedlgproc.inc"


%include "client_confdlgproc.inc"
%include "client_invitationdlgproc.inc"

%include "client_userdlgproc.inc"


%include "client_miscproc.inc"



;;when the client just gets connected to the server..
;; send the buffer containing "acknowledging the connection"  command word and along with that the userid must also be sent..

;; send from client side 0x0101 (ACK_CONN),userid,0  eg)   0x0101,mat_hi,0

;; accept the 0x0102 (GET_USERLIST)command word and add all the ids to the list box....

;; accept the 0x0103 (USER_ADD )command word and add the single user id to the listbox

;; accept the 0x0104 (USER_DEL)command word and delete the single user id from the listbox....

;; accept the 0x0105 (USER_REJ)command word close socket and exit.

;; accept the 0x0106 (PRIVATE_MESS)command word and display private message in appropriate window(sender name).

;; send 0x0106 (PRIVATE_MESS)along with recepient name and private mess.

;; send 0x0107 (CONF_INVITATION)along with recepient names ..

;; accept 0x0108 (CONF_INVI_ACK)and start the corresponding conference dialog.

;; accept 0x0109 (CONF_INVITATION_REAL)and start the invitation dialog (with buttons join and decline).

;; send and accept 0x0110 (CONF_MESS)with conference name and conference message.

;; send 0x0111 (JOIN_CONF)with conference name to join the conference.

;; send 0x0112 (LEAVE_CONF)with conference name to leave the conference.

;; accept 0x0113 (GET_CONFLIST)and get the list of users in a particular conference.

;; accept 0x0114 (USER_JOINED_CONF)and add the user id of the newly joined user in the listbox of the corresponding conference dialog.

;; accept 0x0115 (USER_LEFT_CONF)and delete the user id of the user who left from the listbox of the corresponding conference dialog.

;; accept 0x0116 (LATE_CONF)and display message box " late for conference"

;; send 0x0117(CONF_INVITATION_CHAIN ) with recepients id.(sent if invited from the conference dialog)

;; accept 0x0118 (YES_CONF)and set focus to the user edit of the corresponding conference dialog.
